<?php
// Ü

/**** Klasse für Telegram in Verbindung mit einer DB
*
*	@Author: Jan Clauß
* @Version: 1.31 (2022-01-12)
* 
*	1.3 sendReplyMessage
* Required Class telegram
*
* 1.31 sqlbotconf anpassungen (savesqlbotconf)
*/

include_once "telegramclass.php.inc";

class telegramdb extends telegram
{
	
	public $pdo = null; // Das PDO-object für den Bot (Constructor)
	public $database_table_telegram = ''; // Die Datenbank für den Bot (Constructor)
	public $database_table_botconf = ''; // Extra DB-Tabelle für die Bot-Konfiguration
	public $updateuserdata = false; // Aktualisiere die Userdaten in der DB selbstständig
	public $default_timezone = 'Europe/Berlin';
	public $default_language = 'ger';
	public $default_botconf = '[]';
	public $kommandovalid = 10*60; // Gültigkeit eines Kommandos, also wie lange wird auf eine Antwort gewartet
	
	public $rightsarray=array('mod' => 10,'user' => 8,'waiting' => 6,'ignore' => 4, 'block' => 2);
	
	// Bot-Konfiguration in DB-Satz 0 // Die Daten sollten erst bei Nutzung geladen werden und auch gleich wieder zurück geschrieben werden, da Instanzen des Bot parallel laufen
	public $masterbotconf=null;
	public $masterbotconf_hash='';
	
	// Bot-Konfiguration in extra DB-Datenbank (Hält nur geladene Daten im Array und schreibt direkt zurück (getsqlbotconf, setsqlbotconf)
	public $sqlbotconf=array();
	
	// Werden von decodemessage - get_userdata gefüllt
	public $user_id=0; // User-ID aus letzter Nachricht
	public $username='';
	public $first_name='';
	public $last_name='';
	public $language_code='';
	public $rights='block';
	public $rightslevel=0;
	public $language='ger';
	public $timezone='Europe/Berlin';
	public $command='';
	public $botconf='';
	public $lastkontakt=0;
	
	public $chat_defaultrights='waiting';
	public $chat_id=0; // User-ID des Chats, bei Gruppen unterschiedlich zur User-id (user_id Sender-ID, Chat_ID ist die ID der Gruppe
	public $chat_title='';
	public $chat_rights='waiting';
	public $chat_rightslevel=0;
	public $chat_type='';
	public $chat_usedb=false; // Legt für den Chat einen extra Datensatz an
	public $chat_language='ger';
	public $chat_timezone='Europe/Berlin';
	public $chat_botconf=array();
	public $chat_lastkontakt=0;
	
	public $cancelstring='/cancel';
	public $cancelstringausgabe='canceled';
	public $cancelthenexit=false; // Nach dem Abbrechen des Kommandos wird die Script-Ausführung beendet
	
	public $translate_class=null; // Verknüpfung zur Translateclass, damit bei neuen Usern die möglichen Sprachen abgefragt werden können
	public $translate_languages=array( // Enthält Zuordnungen Telegram Languagecodes -> Translateclass-Codes
	  'de' => 'ger', // Deutsch
	 );
	
	function __construct($bot_token, $pdoobj, $database_table)
	{
		parent::__construct($bot_token);
		if(!is_a($pdoobj, 'PDO')) 
//		if(!is_object($pdoobj))
			return(array('ok' => false, 'error_code' => '1', 'description' => '$pdo must be an Database Object'));
		$this->pdo=$pdoobj;
		$this->database_table_telegram=$database_table;
		$this->database_table_botconf=$database_table.'_botconf';
		
		return(array('ok' => true));
  }
  
	/*
	* readmasterbotconf
	*
	* Liest, wenn aktiviert die Masterbotconf aus DB mit user_id=0
	* Erstellt eine Prüfsumme über die gelesene Botconf
	
	public $masterbotconf=null;
	public $masterbotconf_hash='';

	*/
	public function readmasterbotconf()
	{
  	$sql="SELECT botconfjson FROM ".$this->database_table_telegram." WHERE user_id=0";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
//			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(false);
		}else{
			$this->masterbotconf=array();
			if($stm_all->rowCount() == 1) {
				$result=$stm_all->fetch();
				$masterbotconf=json_decode($result['botconfjson'],true);
				if(is_array($masterbotconf)) $this->masterbotconf=$masterbotconf;
				$this->masterbotconf_hash=sha1(json_encode($this->masterbotconf));
			}else{
				// Datensatz 0 anlegen
				$sql="INSERT INTO ".$this->database_table_telegram." SET user_id=0, first_name='Bot-Master-DS', commandjson='[]', botconfjson='[]'";
				error_log($sql);
				$stm_all=$this->pdo->prepare($sql);
				$stm_all->execute();
				if($stm_all->errorInfo()[0]<>'00000') {
					error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
//					if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
					return(false);
				}
			}
		}
		return true;
	}
	
	/*
	* writemasterbotconf
	*
	* Schreibt, wenn aktiviert und sich etwas geändert hat die Masterbotconf in DB mit user_id=0
	* Zur Prüfung auf die Veränderung wird der Hash benutzt
	*/
	public function writemasterbotconf()
	{
		if(($this->masterbotconf_hash == '' and count($this->masterbotconf) > 0) or // Erste Daten 
		   ($this->masterbotconf_hash <> sha1(json_encode($this->masterbotconf)))) { // Daten haben sich geändert
			$sql="UPDATE ".$this->database_table_telegram." SET botconfjson=:botconfjson, lastkontakt=:time WHERE user_id=0";
			$stm_all=$this->pdo->prepare($sql);
			$masterbotconf_json=json_encode($this->masterbotconf);
			$time=time();
			$stm_all->bindParam(':botconfjson',$masterbotconf_json, PDO::PARAM_STR);
			$stm_all->bindParam(':time',$time, PDO::PARAM_INT);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
//				if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				return(false);
			}else{
				$this->masterbotconf_hash=sha1(json_encode($this->masterbotconf)); // Hash aktualisieren
			}
		}
	}
	
	/*
	* masterbotconfset
	*
	* Schreibt Daten in das Mysql-JSON-Feld botconfjson des Datensatzen 0 (Masterbotconf)
	* 
	* @param string $jsonfield - Feld innerhab des JSON in MSQL Form "$index.index..."
	* @param ** $value Der Wert, als Array, String oder Integer
	*/
	public function masterbotconfset($jsonfield, $value)
	{
		$sql='UPDATE '.$this->database_table_telegram.' SET botconfjson = JSON_SET(botconfjson, "'.$jsonfield.'", :value) WHERE user_id=0';
		$stm_all=$this->pdo->prepare($sql);
		if(is_array($value)) $value=json_encode($value);
		if(is_integer($value)) {
			$stm_all->bindParam(':value',$value, PDO::PARAM_INT);
		}else{
			$stm_all->bindParam(':value',$value, PDO::PARAM_STR);
		}
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return false;
		}
		$this->readmasterbotconf();
		return true;
	}
	
	/*
	* masterbotconfremove
	*
	* löscht Daten aus dem  Mysql-JSON-Feld botconfjson des Datensatzen 0 (Masterbotconf)
	* 
	* @param string $jsonfield - Feld innerhab des JSON in MSQL Form "$index.index..."
	*/
	public function masterbotconfremove($jsonfield)
	{
		$sql='UPDATE '.$this->database_table_telegram.' SET botconfjson = JSON_REMOVE(botconfjson, "'.$jsonfield.'") WHERE user_id=0';
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return false;
		}
		$this->readmasterbotconf();
		return true;
	}
	
	/** 
	* createsqlbotconf
	*
	* Anlegen der Botconf-Tabelle
	*/
	function createsqlbotconf()
	{
  	global
  		$database_name;
  	$database_table_botconf=$this->database_table_botconf;
		$tablename=substr($database_table_botconf, strlen($database_name)+1);
		$this->pdo->exec("USE $database_name");
		$sql="
	CREATE TABLE `$tablename` (
	`gruppe` VARCHAR(255) NOT NULL COLLATE 'utf8mb4_bin',
	`subgr` VARCHAR(255) NOT NULL COLLATE 'utf8mb4_bin',
	`data` LONGTEXT NOT NULL COLLATE 'utf8mb4_bin',
	`lastchange` INT(11) NOT NULL DEFAULT '0',
	UNIQUE INDEX `gruppe_subgr` (`gruppe`, `subgr`) USING BTREE
)
COLLATE='utf8mb4_bin'
ENGINE=InnoDB
;";
		$result=$this->pdo->exec($sql);
		if($result === false) {
			error_log(__FILE__.' '. __LINE__.' '.print_r($this->pdo->errorInfo(),true));
			if($logaus and function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$this->pdo->errorInfo(),'main');
			return false;
		}
		error_log(__FILE__.' '.__LINE__.' Database table created');
		return true;
	}
	
	/**
	* savesqlbotconf
	*
	*
	*/
	function savesqlbotconf($group, $key, $logaus=true) {
  	$database_table_botconf=$this->database_table_botconf;
  	
		if(!IsSet($this->sqlbotconf[$group][$key])) {
			// Daten aus DB löschen
  		$sql="DELETE FROM $database_table_botconf WHERE gruppe=:gruppe and subgr=:subgr";
			$stm_all=$this->pdo->prepare($sql);
			$time=time();
			$stm_all->bindParam(':gruppe',$group, PDO::PARAM_STR);
			$stm_all->bindParam(':subgr',$key, PDO::PARAM_STR);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
				if($logaus and function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				return false;
			}
  		return true;
		}else{
			// Daten in DB schreiben / aktualisieren
			$data=$this->sqlbotconf[$group][$key];
  		if(is_array($data)) $data=json_encode($data); // Ist es ein Array dann in json / string wandeln
	  	$sql="INSERT INTO $database_table_botconf SET gruppe=:gruppe, subgr=:subgr, data=:data, lastchange=:time ON DUPLICATE KEY UPDATE data=:data, lastchange=:time";
			$stm_all=$this->pdo->prepare($sql);
			$time=time();
			$stm_all->bindParam(':gruppe',$group, PDO::PARAM_STR);
			$stm_all->bindParam(':subgr',$key, PDO::PARAM_STR);
			$stm_all->bindParam(':data',$data, PDO::PARAM_STR);
			$stm_all->bindParam(':time',$time, PDO::PARAM_INT);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
				if($stm_all->errorInfo()[0] =='42S02') { // Tabelle existiert nicht
					$this->createsqlbotconf();
				}
				if($logaus and function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				return false;
			}
			return true;
		}
	}
	
  /**
  * setsqlbotconf
  * 
  * Schreibt die Daten in $this->sqlbotconf[$group][$key] und in die botconf DB
  * ist $data == null wird der Satz gelöscht
  *
  */
  function setsqlbotconf($group, $key, $data, $logaus=true) {
  	if($data == null) { // Datensatz löschen
  		unset($this->sqlbotconf[$group][$key]);
  	}else{
	  	$this->sqlbotconf[$group][$key]=$data;
	  }
	  return $this->savesqlbotconf($group, $key, $logaus);
	}

  
  /**
  * getsqlbotconf
  *
  * Liest eine die Daten unter group key aus dem array, wenn dort nicht vorhanden aus der DB
  *
  */
  function getsqlbotconf($group, $key, $logaus=true) {
  	if(IsSet($this->sqlbotconf[$group][$key])) { // Daten im sqlbotconf Array zwischengespeichert
  		return($this->sqlbotconf[$group][$key]);
  	}
  	$database_table_botconf=$this->database_table_botconf;
  	$sql="SELECT data FROM $database_table_botconf WHERE gruppe=:gruppe and subgr=:subgr";
		$stm_all=$this->pdo->prepare($sql);
		$time=time();
		$stm_all->bindParam(':gruppe',$group, PDO::PARAM_STR);
		$stm_all->bindParam(':subgr',$key, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if($stm_all->errorInfo()[0] =='42S02') { // Tabelle existiert nicht
				$this->createsqlbotconf();
			}
			if($logaus and function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return false;
		}
		if($stm_all->rowCount() == 1) {
			$result=$stm_all->fetch(PDO::FETCH_NUM);
			$resultjson=json_decode($result[0],true);
			if(is_array($resultjson)) { // Enthielt ein JSON-Objeckt
				$this->sqlbotconf[$group][$key]=$resultjson;
				return $resultjson;
			}
			$this->sqlbotconf[$group][$key]=$result[0];
			return($result[0]);
		}else{
			return null;
		}
  }
  
  /**
  * readsqlbotconf
  *
  * Liest eine ganze Gruppe aus der DB in das Array
  *
  */
  function readsqlbotconf($group, $logaus=true) {
  	$database_table_botconf=$this->database_table_botconf;
  	$sql="SELECT subgr, data FROM $database_table_botconf WHERE gruppe=:gruppe";
		$stm_all=$this->pdo->prepare($sql);
		$time=time();
		$stm_all->bindParam(':gruppe',$group, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if($logaus and function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return false;
		}
		while($result=$stm_all->fetch(PDO::FETCH_ASSOC)) {
			$key=$result['subgr'];
			$resultjson=json_decode($result['data'],true);
			if(is_array($resultjson)) { // Enthielt ein JSON-Objeckt
				$this->sqlbotconf[$group][$key]=$resultjson;
			}else{
				$this->sqlbotconf[$group][$key]=$result['data'];
			}
		}
		if(IsSet($this->sqlbotconf[$group])) {
			return $this->sqlbotconf[$group];
		}else{
			return true;
		}
  }
  
  /**
  * resetsqlbotconfarr
  *
  * Löscht die zwischengespeicherten Daten aus dem Array, sodass sie wieder aus der DB geladen werden müssen
  */
  function resetsqlbotconfarr()
  {
  	$this->sqlbotconf=array();
  }
  
  /** searchsqlbotconf
  *
  * sucht nach einem Datenstring in der sqlbotconf
  */
  function searchsqlbotconf($group, $data) {
  	$database_table_botconf=$this->database_table_botconf;
  	$sql="SELECT subgr FROM $database_table_botconf WHERE gruppe=:gruppe and data=:data";
		$stm_all=$this->pdo->prepare($sql);
		$time=time();
		$stm_all->bindParam(':gruppe',$group, PDO::PARAM_STR);
		$stm_all->bindParam(':data',$data, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if($logaus and function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return false;
		}
		if($stm_all->rowCount() == 0) {
			return null;
		}
		$result=$stm_all->fetchall();
		return $result;
  }
  
  function createdb($defaultrights='waiting')
  {
  	$db=explode('.',$this->database_table_telegram);
  	$database=$db[0];
  	$table=$db[1];
  	$sql="USE $database";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(json_encode(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo())));
		}
  	$sql="
CREATE TABLE IF NOT EXISTS `".$table."` (
	`user_id` BIGINT(20) NOT NULL,
	`user_name` VARCHAR(255) NOT NULL DEFAULT '' COLLATE 'utf8mb4_bin',
	`first_name` VARCHAR(255) NOT NULL DEFAULT '' COLLATE 'utf8mb4_bin',
	`last_name` VARCHAR(255) NOT NULL DEFAULT '' COLLATE 'utf8mb4_bin',
	`rights` ENUM('mod','user','waiting','ignore','block') NOT NULL DEFAULT '".$defaultrights."' COLLATE 'utf8mb4_bin',
	`language` CHAR(10) NOT NULL DEFAULT 'ger' COLLATE 'utf8mb4_bin',
	`timezone` VARCHAR(255) NOT NULL DEFAULT 'Europe/Berlin' COLLATE 'utf8mb4_bin',
	`commandjson` TEXT(65535) NOT NULL COLLATE 'utf8mb4_bin',
	`botconfjson` JSON NOT NULL,
	`lastkontakt` INT(11) NOT NULL DEFAULT '0',
	`grouptools` ENUM('Y','N') NOT NULL DEFAULT 'Y' COMMENT 'Zum Gruppieren bei Abfragen' COLLATE 'utf8mb4_bin',
	UNIQUE INDEX `user_id` (`user_id`) USING BTREE
)
COLLATE='utf8mb4_bin'
ENGINE=InnoDB
;
";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
		}
		return array('ok' => true, 'db' => $database, 'table' => $table);
  }
  
  //************************** 2020-12-14
  //* ALTER TABLE `".$table."`	
	//* CHANGE COLUMN `user_id` `user_id` BIGINT NOT NULL DEFAULT 0 FIRST;
	//**************************
  
  private function get_userdata($user_arr,$autoinsert=false,$recursion=false)
  // Nur für den aktuellen User, die Werte des Users werden in die Klasse eingetragen, 
  // der User wird ggfls angelegt (wenn Kommando /start ist, oder wenn autoinsert=true)
  // $recursion wrd nur intern genutzt
  // Werden Daten eines Nutzers gebraucht, verwende getuserds()
  {
  	$user_id=$user_arr['user_id'];
  	$this->user_id=$user_id; //Selbst wenn User nicht in DB, die User_id ist bekannt
  	$this->language_code=$user_arr['language_code']; // Wird nicht in der DB gespeichert, dafür ist language da.
		// Chat-Daten
		$this->chat_id=$user_arr['chat']['id'];
		if(IsSet($user_arr['chat']['title'])) $this->chat_title=$user_arr['chat']['title'];
		$this->chat_type=$user_arr['chat']['type'];
  	$commandjson='[]';
  	$lastkontakt=time();
  	$sql="SELECT user_name, first_name, last_name, rights, language, timezone, commandjson, botconfjson, lastkontakt FROM ".$this->database_table_telegram." WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
		}else{
			if($stm_all->rowCount() <> 1) {
				// User nicht in DB gefunden
				if(($user_arr['command'] == '/start' or $autoinsert == true) and $recursion == false) { // Nur eine Recursion erlaubt
					//User meldet sich am Bot an, Datenbankeintrag erstellen
					$sql="INSERT INTO ".$this->database_table_telegram." SET user_id=:user_id, user_name=:user_name, first_name=:first_name, last_name=:last_name, commandjson='[]', botconfjson=:botconfjson, lastkontakt=:lastkontakt, timezone=:timezone, language=:language";
					$stm_all=$this->pdo->prepare($sql);
					$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
					$stm_all->bindParam(':user_name',$user_arr['username'], PDO::PARAM_STR);
					$stm_all->bindParam(':first_name',$user_arr['first_name'], PDO::PARAM_STR);
					$stm_all->bindParam(':last_name',$user_arr['last_name'], PDO::PARAM_STR);
					$stm_all->bindParam(':botconfjson',$this->default_botconf, PDO::PARAM_STR);
					$stm_all->bindParam(':lastkontakt',$lastkontakt, PDO::PARAM_INT);
					$stm_all->bindParam(':timezone',$this->default_timezone, PDO::PARAM_STR);
					$language=$this->default_language;
					if(is_a($this->translate_class, 'translate')) { // Translateclass verbunden, prüfen ob die Sprache des Clients im Bot existiert
						if($this->translate_class->iflanguage($user_arr['language_code'])) { // Existiert das Sprachkürzel aus der Telegramnachricht?
							$language=$user_arr['language_code']; // Sprache direkt setzen
						}elseif(IsSet($this->translate_languages[$user_arr['language_code']])) { // Sprachkürzel existiert in der ZUordnungstabelle der Telegramdbklasse
							$lang=$this->translate_languages[$user_arr['language_code']];
							if($this->translate_class->iflanguage($lang)) {
								$language=$lang;
							}
						}
					}
					$stm_all->bindParam(':language',$language, PDO::PARAM_STR);
					$stm_all->execute();
					if($stm_all->errorInfo()[0]<>'00000') {
						error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
						if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
						$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
					}else{
						$ret=$this->get_userdata($user_arr,$autoinsert,true); // Einfach selber aufrufen, um die Daten in $ret zu laden
					}
				}else{
					$ret=array('ok' => false, 'error_code' => '1', 'description' => 'User not found');
				}
			}else{
				// User in DB
				$ret['ok'] = true;
				$ret['user_id'] = $user_id;
				$this->user_id = $user_id;
				$retarr=$stm_all->fetch(PDO::FETCH_ASSOC);
				$ret['username'] = $retarr['user_name'];
				$this->username = $retarr['user_name'];
				$ret['first_name'] = $retarr['first_name'];
				$this->first_name = $retarr['first_name'];
				$ret['last_name'] = $retarr['last_name'];
				$this->last_name = $retarr['last_name'];
				$ret['rights'] = $retarr['rights'];
				$this->rights = $retarr['rights'];
				$ret['rightslevel']=$this->rightsarray[$retarr['rights']];
				$this->rightslevel=$this->rightsarray[$retarr['rights']];
				$ret['language'] = $retarr['language'];
				$this->language = $retarr['language'];
				$ret['timezone'] = $retarr['timezone'];
				$this->timezone = $retarr['timezone'];
				$ret['command'] = json_decode($retarr['commandjson'],true);
				$this->command = json_decode($retarr['commandjson'],true);
				$ret['botconf'] = json_decode($retarr['botconfjson'],true);
				$this->botconf = json_decode($retarr['botconfjson'],true);
				$ret['lastkontakt'] = $retarr['lastkontakt'];
				$this->lastkontakt = $retarr['lastkontakt'];
				// Daten in DB aktualisieren?
				if($this->updateuserdata and ($this->username <> $user_arr['username'] or $this->first_name <> $user_arr['first_name'] or $this->last_name <> $user_arr['last_name'])) {
					$sql="UPDATE ".$this->database_table_telegram." SET user_name=:user_name, first_name=:first_name, last_name=:last_name WHERE user_id=:user_id";
					$stm_all=$this->pdo->prepare($sql);
					$stm_all->bindParam(':user_name',$user_arr['username'], PDO::PARAM_STR);
					$stm_all->bindParam(':first_name',$user_arr['first_name'], PDO::PARAM_STR);
					$stm_all->bindParam(':last_name',$user_arr['last_name'], PDO::PARAM_STR);
					$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
					$stm_all->execute();
					if($stm_all->errorInfo()[0]<>'00000') {
						error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
						if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
					}
				}
				// Lastkontakt aktualisieren
				$sql="UPDATE ".$this->database_table_telegram." SET lastkontakt=:lastkontakt WHERE user_id=:user_id";
				$stm_all=$this->pdo->prepare($sql);
				$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
				$stm_all->bindParam(':lastkontakt',$lastkontakt, PDO::PARAM_INT);
				$stm_all->execute();
				if($stm_all->errorInfo()[0]<>'00000') {
					error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
					if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				}
			}
			if($user_arr['chat']['id'] <> $user_id) { // Kein privater Chat
				$chat_id=$user_arr['chat']['id'];
				if(($user_arr['chat']['type'] == 'group' or $user_arr['chat']['type'] == 'supergroup') and $this->chat_usedb==true) {  // Erst mal nur bei Gruppen, anderes noch testen
					// Chat-Daten Abfragen
  				$sql="SELECT user_name, first_name, rights, language, timezone, botconfjson, lastkontakt FROM ".$this->database_table_telegram." WHERE user_id=:chat_id";
					$stm_all=$this->pdo->prepare($sql);
					$stm_all->bindParam(':chat_id',$chat_id, PDO::PARAM_INT);
					$stm_all->execute();
					if($stm_all->errorInfo()[0]<>'00000') {
						error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
						if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
						$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
					}else{
						if($stm_all->rowCount() <> 1) {
							// Chat anlegen
							$sql="INSERT INTO ".$this->database_table_telegram." SET user_id=:chat_id, user_name=:chat_type, first_name=:chat_title, rights=:chat_rights, timezone=:timezone, language=:language, botconfjson=:botconfjson, lastkontakt=:lastkontakt, commandjson=''";
							$stm_all=$this->pdo->prepare($sql);
							$stm_all->bindParam(':chat_id',$this->chat_id, PDO::PARAM_INT);
							$stm_all->bindParam(':chat_type',$this->chat_type);
							$stm_all->bindParam(':chat_title',$this->chat_title, PDO::PARAM_STR);
							$stm_all->bindParam(':chat_rights',$this->chat_defaultrights, PDO::PARAM_STR);
							$chat_botconfjson=json_encode($this->chat_botconf);
							$stm_all->bindParam(':botconfjson',$chat_botconfjson, PDO::PARAM_STR); // Es ist eh noch nix in der botconf
							$stm_all->bindParam(':timezone',$this->chat_timezone, PDO::PARAM_STR);
							$stm_all->bindParam(':language',$this->chat_language, PDO::PARAM_STR);
							$stm_all->bindParam(':lastkontakt',$lastkontakt,PDO::PARAM_INT);
							$stm_all->execute();
							if($stm_all->errorInfo()[0]<>'00000') {
								error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
								if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
								$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
							}
							$this->chat_rights=$this->chat_defaultrights;
							$this->chat_rightslevel=$this->rightsarray[$this->chat_rights];
							$this->chat_lastkontakt=$lastkontakt;
						}else{
							// Chat-Daten laden
							$retarr=$stm_all->fetch(PDO::FETCH_ASSOC);
							if($retarr['first_name'] <> $this->chat_title or $retarr['user_name'] <> $this->chat_type) {
								$sql="UPDATE ".$this->database_table_telegram." SET first_name=:chat_title, user_name=:chat_type WHERE user_id=:chat_id";
								$stm_all=$this->pdo->prepare($sql);
								$stm_all->bindParam(':chat_id',$this->chat_id, PDO::PARAM_INT);
								$stm_all->bindParam(':chat_title',$this->chat_title, PDO::PARAM_STR);
								$stm_all->bindParam(':chat_type',$this->chat_type);
								$stm_all->execute();
								if($stm_all->errorInfo()[0]<>'00000') {
									error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
									if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
								}
							}
							$this->chat_rights=$retarr['rights'];
							$this->chat_rightslevel=$this->rightsarray[$this->chat_rights];
							$this->chat_language=$retarr['language'];
							$this->chat_timezone=$retarr['timezone'];
							$this->chat_botconf=json_decode($retarr['botconfjson'],true);
							if(!is_array($this->chat_botconf)) $this->chat_botconf=array();
							$this->chat_lastkontakt=$retarr['lastkontakt'];
							// lastkontakt aktualisieren
							$sql="UPDATE ".$this->database_table_telegram." SET lastkontakt=:lastkontakt WHERE user_id=:chat_id";
							$stm_all=$this->pdo->prepare($sql);
							$stm_all->bindParam(':chat_id',$this->chat_id, PDO::PARAM_INT);
							$stm_all->bindParam(':lastkontakt',$lastkontakt, PDO::PARAM_INT);
							$stm_all->execute();
							if($stm_all->errorInfo()[0]<>'00000') {
								error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
								if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
							}
						}
					}
				}
			}
		}
		return($ret);
  }

	public function decodemessage($message,$autoinsert=false)	
	// if $autoinsert == true, wird der Nutzer automatisch angelegt, ohne /start
	{
		$ret=parent::decodemessage($message);
		if(IsSet($ret['message_typ'])) {
			$dbdata=$this->get_userdata($ret,$autoinsert);
			$ret['db']=$dbdata;
			if(!IsSet($ret['chat']['type']) or $ret['chat']['type'] == 'private') { // Damit ein im Privaten ausgeführtes Kommando keinen Chat behindert
				if(IsSet($ret['db']['command']['command']) and $ret['db']['command']['command'] <> '' and IsSet($ret['text']) and strtolower(substr(trim($ret['text']),0,strlen($this->cancelstring))) == strtolower($this->cancelstring)) {
					// Internes Kommando abbrechen
					$this->setcommand($this->user_id,'');
					if(IsSet($ret['db']['command']['command'])) unset($ret['db']['command']['command']);
					if($this->cancelstringausgabe <> '') $this->sendmessage($this->user_id,$this->cancelstringausgabe);
					if($this->cancelthenexit == true) exit();
				}
				if(IsSet($ret['db']['command']['command']) and $ret['db']['command']['command'] <> '' and $ret['db']['command']['commandtime'] > time() - $this->kommandovalid) { // Kommandos älter als kommandvalid s werden ignoriert
					if($ret['db']['command']['replymessageid'] == 0 or (IsSet($ret['replytomessage_id']) and $ret['replytomessage_id'] == $ret['db']['command']['replymessageid'])) { // Kommando wartet auf keine Replymessage oder Replymessage Id's stimmen überein
						$ret['message_typ']='command';
						if(count($ret['db']['command']['args'])>0) { // Argumente in Array args übergeben
							$ret['command']=$ret['db']['command']['command'];
							$ret['args']=$ret['db']['command']['args'];
						}elseif(preg_match('/^(\/?[a-z0-9]+)(.*)/i',$ret['db']['command']['command'],$arr)) { // Argumente mit Kommando übergeben oder keine Argumente
							$ret['command']=$arr[1];
							$ret['args']=array();
							if(trim($arr[2]) <> '') {
								preg_match_all('/([^ ]+)/',$arr[2], $args);
								$ret['args']=$args[0];
							}
						}
					}
				}
			}
		}
		return($ret);
	}
	
	public function MigrateFromChatId($old, $new)
	{
		$sql="UPDATE ".$this->database_table_telegram." SET user_id=:chat_id WHERE user_id=:from_chat_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':chat_id',$new, PDO::PARAM_INT);
		$stm_all->bindParam(':from_chat_id',$old, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
		}
		parent::MigrateFromChatId($old, $new);
	}	
	
	public function setcommand($user_id, $command, $args=array(), $replymessageid=0)
	{
		if($user_id == 0) $user_id=$this->user_id;
		$arr['command']=$command;
		$arr['commandtime']=time();
		$arr['args']=$args;
		$arr['replymessageid']=$replymessageid;
		$json=json_encode($arr);
		$sql="UPDATE ".$this->database_table_telegram." SET commandjson=:commandjson WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->bindParam(':commandjson',$json, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
		}else{
			$ret=array('ok' => true);
		}
	}	
	
	/*
	* sendReplyMessage
	*
	* Sendet eine Nachricht und fordert zur Antwort auf
	*/
	function sendReplyMessage($user_id, $text, $command, $args=array())
	{
		if(!is_array($text)) { // Nur Text übergeben
			$answer=array(
				'text' => $text,
				'reply_markup' => json_encode(['force_reply' => true]),
			);
		}else{
			if(!IsSet($text['reply_markup'])) { // Ergänzen um reply_markup
				$text['reply_markup']=json_encode(['force_reply' => true]);
			}
			$answer=$text;
		}
		$result=$this->sendmessage($user_id, $answer);
		if($result['ok'] == true) {
			$this->setcommand($user_id, $command, $args, $result['result']['message_id']);
		}
	}
	
	public function sendReplyDocumentById($user_id, $file_id, $text, $command, $args=array())
	{
		$result=$this->sendDocumentById($user_id, $file_id, $text, json_encode(['force_reply' => true]));
		if($result['ok'] == true) {
			$this->setcommand($user_id, $command, $args, $result['result']['message_id']);
		}
		return $result;
	}
	
	public function sendReplyPhotoById($user_id, $img_id, $text, $command, $args=array())
	{
		$result=$this->sendPhotoById($user_id, $img_id, $text, json_encode(['force_reply' => true]));
		if($result['ok'] == true) {
			$this->setcommand($user_id, $command, $args, $result['result']['message_id']);
		}
		return $result;
	}
	
	public function writebotconf($user_id=0, $botconf='-')
	{
		if($botconf == '-') $botconf=$this->botconf;
		if($user_id == 0) $user_id=$this->user_id;
		if(!is_array($botconf)) {
			error_log(__FILE__.', Line '.__LINE__.' Botconf kein Array'); // Schutz vor dem Fehlerhaften überschreiben der Botconf
		}else{
			$json=json_encode($botconf);
			$sql="UPDATE ".$this->database_table_telegram." SET botconfjson=:botconf WHERE user_id=:user_id";
			$stm_all=$this->pdo->prepare($sql);
			$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
			$stm_all->bindParam(':botconf',$json, PDO::PARAM_STR);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
				if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
			}else{
				$ret=array('ok' => true);
			}
		}
	}

	public function chat_readbotconf($chat_id=0)
	{
		$sql="SELECT botconfjson FROM ".$this->database_table_telegram." WHERE user_id=:chat_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':chat_id',$chat_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
		}else{
			if($stm_all->rowCount() == 1) {
				$result=$stm_all->fetch();
				$this->chat_botconf=json_decode($result['botconfjson'],true);
			}
		}
	}

	public function chat_writebotconf($chat_id=0, $botconf='-')
	{
		if($botconf == '-') $botconf=$this->chat_botconf;
		if($chat_id == 0) $chat_id=$this->chat_id;
		if(!is_array($botconf)) {
			error_log(__FILE__.', Line '.__LINE__.' Botconf kein Array'); // Schutz vor dem Fehlerhaften überschreiben der Botconf
		}else{
			$json=json_encode($botconf);
			$sql="UPDATE ".$this->database_table_telegram." SET botconfjson=:botconf WHERE user_id=:chat_id";
			$stm_all=$this->pdo->prepare($sql);
			$stm_all->bindParam(':chat_id',$chat_id, PDO::PARAM_INT);
			$stm_all->bindParam(':botconf',$json, PDO::PARAM_STR);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
				if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				$ret=array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo());
			}else{
				$ret=array('ok' => true);
			}
		}
	}

	public function settimezone($user_id, $timezone)
	{
		if(!date_default_timezone_set($timezone))	{
			return(array('ok' => false, 'error_code' => '1', 'description' => 'Timezone Error', 'errorInfo' => 'false Timezone'));
		}
		$sql="UPDATE ".$this->database_table_telegram." SET timezone=:timezone WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->bindParam(':timezone',$timezone, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}else{
			return(array('ok' => true));
		}
	}
	
	public function setlanguage($user_id, $language)
	{
		if(!preg_match('/^([a-z0-9]+)$/i', strtolower($language), $arr)) {
			return(array('ok' => false, 'error_code' => '1', 'description' => 'Language Error', 'errorInfo' => 'Invalid characters'));
		}else{
			$sql="UPDATE ".$this->database_table_telegram." SET language=:language WHERE user_id=:user_id";
			$stm_all=$this->pdo->prepare($sql);
			$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
			$stm_all->bindParam(':language',$arr[1], PDO::PARAM_STR);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
				if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
			}else{
				return(array('ok' => true));
			}
		}
	}
	
	public function deleteuser($user_id)
	{
		$sql="DELETE FROM ".$this->database_table_telegram." WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}else{
			return(array('ok' => true));
		}
	}
	
	public function getuserrights($user_id)
	{
		$sql="SELECT user_name, first_name, last_name, rights FROM ".$this->database_table_telegram." WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}else{
			if($stm_all->rowCount() <> 1) {
				return(array('ok' => false, 'error_code' => '3', 'description' => 'User not found','errorInfo' => 'User not found'));
			}
			$resarr=$stm_all->fetch(PDO::FETCH_ASSOC);
			return(array('ok' => true, 'user_name' => $resarr['user_name'], 'first_name' => $resarr['first_name'], 'last_name' => $resarr['last_name'], 'rights' => $resarr['rights']));
		}
	}
	
	public function getuseridfromname($username) {
		// Username muss mit @ übergeben werden!
		if(preg_match('/^@([a-z][a-z0-9_]+)$/i',$username,$arr)) {
			$sql="SELECT user_id FROM ".$this->database_table_telegram." WHERE user_name=:arr1";
			$stm_all=$this->pdo->prepare($sql);
			$stm_all->bindParam(':arr1',$arr[1], PDO::PARAM_STR);
		}elseif(preg_match('/^([0-9]+)$/',$username,$arr)) {
			$sql="SELECT user_id FROM ".$this->database_table_telegram." WHERE user_id=:arr1";
			$stm_all=$this->pdo->prepare($sql);
			$stm_all->bindParam(':arr1',$arr[1], PDO::PARAM_INT);
		}else{
			return(array('ok' => false, 'error_code' => '2', 'description' => 'No Username or id'));
		}
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}else{
			if($stm_all->rowCount() == 1) {
				$resarr=$stm_all->fetch(PDO::FETCH_ASSOC);
				return(array('ok' => true, 'user_id' => $resarr['user_id']));
			}else{
				return(array('ok' => false, 'error_code' => '1', 'description' => 'User not found'));
			}
		}
	}

	public function getuserds($user_id)
	// Liefert den DB-Datensatz des Nutzers, ['botconfjson'] kommt zusätzlich decodiert in ['botconf']
	{
  	$sql="SELECT * FROM ".$this->database_table_telegram." WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}else{
			if($stm_all->rowCount() <> 1) {
				return(array('ok' => false, 'error_code' => '3', 'description' => 'User not found','errorInfo' => 'User not found'));
			}else{
				$resarr=$stm_all->fetch(PDO::FETCH_ASSOC);
				$resarr['botconf']=json_decode($resarr['botconfjson'],true);
				$resarr['ok']=true;
				return($resarr);
			}
		}
	}
	
	public function getmods()
	{
		$sql="SELECT user_id FROM ".$this->database_table_telegram." WHERE rights='mod' and user_id<>0";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'Error','errorInfo' => $stm_all->errorInfo()));
		}
		while($resarr=$stm_all->fetch(PDO::FETCH_ASSOC)) {
			$ret['mods'][]=$resarr['user_id'];
		}
		$ret['ok']=true;
		return($ret);
	}
	
	public function setuserrights($user_id, $rights,$degradieren=false)
	
	// # $user_id - id des zu ändernden Users
	// # $rights - die neuen Rechte
	// # $degradieren - bei true, kann man sich selber degradieren
	{
		$rights=strtolower($rights);
		$old=$this->getuserrights($user_id); // Bestehende Rechte abrufen
		if($old['ok'] == false) { 
			return(array('ok' => false, 'error_code' => '3', 'description' => 'User not found','errorInfo' => 'User not found'));
		}
		if(!$degradieren and $user_id == $this->user_id and $this->rightsarray[$rights] < $this->rightsarray[$this->rights]) {
			return(array('ok' => false, 'error_code' => '4', 'description' => 'Your self','errorInfo' => 'You can not set your own rights'));
		}
		if($old['rights'] == $rights) { // Nix zu ändern
			return($old);
		}
		$sql="UPDATE ".$this->database_table_telegram." SET rights=:rights WHERE user_id=:user_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':user_id',$user_id, PDO::PARAM_INT);
		$stm_all->bindParam(':rights',$rights, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}
		$old['rights']=$rights;  // Neue Rechte ins Array für die Rückgabe
		return($old);
	}
	
	public function removeolduser($tage,$exclude='0')
	//*
	//* $tage, User die länge als $tage nicht am Bot waren werden gelöscht
	//* $exclude, Kommagetrennte Liste ($string) von Usern, die nicht gelöscht werden sollen
	//*
	{
//		global $fs; //!Debug
		$tagetstmp=time()-$tage*24*60*60; // Alle Timestamps die älter sind löschen
		if(!preg_match('/^[0-9,]+$/',$exclude)) { // Parameter $exclude prüfen
			return(array('ok' => false, 'error_code' => '2', 'description' => 'Parameter Fehler','errorInfo' => 'exclude enthält ungültige Liste'));
		}
		$sql="DELETE FROM ".$this->database_table_telegram." WHERE user_id > 0 and lastkontakt<:tagetstmp and rights <> 'mod' and user_id NOT IN ($exclude)";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':tagetstmp',$tagetstmp, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}
		return(array('ok' => true, 'rowCount' => $stm_all->rowCount()));
	}
	
	//*****************************************
	// Chats
	//*****************************************
	
	public function getchats($chattyp='', $testechats=false)
	// ezeugt eine Liste aller Chats
	// $chattyp = group | supergroup - kann einschränken
	// $testechats - Prüft, ob der Bot noch in den Chats ist und löscht sie, wenn nicht
	{
		$sql="SELECT * FROM ".$this->database_table_telegram." WHERE user_id < 0";
		if($chattyp == 'group' or $chattyp == 'supergroup') $sql=' AND user_name=:chattyp';
		$stm_all=$this->pdo->prepare($sql);
		if($chattyp == 'group' or $chattyp == 'supergroup') $stm_all->bind_param(':chattyp', $chattyp, PDO::PARAM_STR);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}
		if($stm_all->rowCount() == 0) {
			// Kein Chat gefunden
			return(array('ok' => true));
		}
		while($resarr=$stm_all->fetch()) {
			if($testechats == true and $this->testechat($resarr['user_id']) == false) {
				$this->deleteuser($resarr['user_id']); // Chat aus der Liste löschen
			}else{
				$retarr[]=array('chat_id' => $resarr['user_id'], 'title' => $resarr['first_name'], 'type' => $resarr['user_name']);
			}
		}
		$ret=array('ok' => true);
		if(IsSet($retarr)) $ret['result']=$retarr;
		return($ret);
	}
	
	public function getchatname($chat_id)
	{
		if($chat_id >= 0) return(false);
		$sql="select first_name FROM ".$this->database_table_telegram." WHERE user_id=$chat_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':chat_id',$chat_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}
		if($stm_all->rowCount() <> 1) return(false);
		$resarr=$stm_all->fetch();
		return($resarr['first_name']);
	}
	
	public function getchatlanguage($chat_id)
	{
		if($chat_id >= 0) return(false);
		$sql="select language FROM ".$this->database_table_telegram." WHERE user_id=$chat_id";
		$stm_all=$this->pdo->prepare($sql);
		$stm_all->bindParam(':chat_id',$chat_id, PDO::PARAM_INT);
		$stm_all->execute();
		if($stm_all->errorInfo()[0]<>'00000') {
			error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
			if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
			return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
		}
		if($stm_all->rowCount() <> 1) return(false);
		$resarr=$stm_all->fetch();
		return($resarr['language']);
	}
	
	public function setchatlanguage($chat_id, $language)
	{
		if(!preg_match('/^([a-z0-9]+)$/i', strtolower($language), $arr)) {
			return(array('ok' => false, 'error_code' => '1', 'description' => 'Language Error', 'errorInfo' => 'Invalid characters'));
		}else{
			$sql="UPDATE ".$this->database_table_telegram." SET language=:language WHERE user_id=:chat_id";
			$stm_all=$this->pdo->prepare($sql);
			$stm_all->bindParam(':chat_id',$chat_id, PDO::PARAM_INT);
			$stm_all->bindParam(':language',$arr[1], PDO::PARAM_STR);
			$stm_all->execute();
			if($stm_all->errorInfo()[0]<>'00000') {
				error_log(__FILE__.' '. __LINE__.' '.print_r($stm_all->errorInfo(),true));
				if(function_exists('logthis')) logthis(__FILE__, __LINE__, 'sql-error',$stm_all->errorInfo(),'main');
				return(array('ok' => false, 'error_code' => '2', 'description' => 'SQL-Error','errorInfo' => $stm_all->errorInfo()));
			}else{
				return(array('ok' => true));
			}
		}
	}
}

?>